/*
Nadrew's Equipment System
	(Formerly: Nadrew's Weapon System)

2004 James "Nadrew" Smith, All Rights Reserved.

This is for educational purposes, not insertion into existing programming.
Edit at your own risk.


Edited versions of this file are NOT supported by the author, and are not to be distributed
without the author's permission.
*/


//Map stuff

mob
	icon = 'mob.dmi'

turf
	icon = 'map.dmi'

//Mob variables

mob
	var
		//basic demo variables for attack and defense
		attack = 0

		//Now, a list for equipment.
		list
			equipment = list("head","neck","body","left arm","right arm","hands","belt","legs","feet")
			//This sets up a list with nine pre-defined body types
			//You can access each with "equipment[space]"


//Items

obj
	equipment
		icon = 'equipment.dmi'
		var
			attackup = 0
			defenseup = 0
		//These variables will be used to determine what modifications need to be done on equip

		//Below are specfic item types based on where they are worn
		head
			helmet
				icon_state = "helmet"
				defenseup = 2
				//This helmet will add two defense points when equipped.

		neck
			necklace
				icon_state = "necklace"
				defenseup = 1

		body
			armor
				icon_state = "armor"
				defenseup = 15

		//The arms will be sub-categorized
		arms
			left	//For the left arm
				shield
					icon_state = "shield"
					defenseup = 5
			right
				sword
					icon_state = "sword"
					attackup = 10

		hands
			ring
				icon_state = "ring"
				defenseup = 1
				attackup = 2
				//This ring adds both attack and defense.

		legs
			leggings
				icon_state = "leggings"
				defenseup = 2

		feet
			boots
				icon_state = "boots"
				defenseup = 2

		//Now for the commands
		verb
			//Picking up and dropping.
			Get()
				set src in oview(1)
				src.Move(usr)
			Drop()
				set src in usr
				for(var/E in usr.equipment)
					if(usr.equipment[E] == src)
						src.Unequip(usr)
				src.Move(usr.loc)

			//Equipping
			Equip()
				set src in usr	//Can only be used from within a player's inventory.

				//Command-only variables
				var
					inventory_slot
				//First, lets get the inventory slot.
				if(istype(src,/obj/equipment/head))
					inventory_slot = "head"
				if(istype(src,/obj/equipment/neck))
					inventory_slot = "neck"
				if(istype(src,/obj/equipment/body))
					inventory_slot = "body"
				if(istype(src,/obj/equipment/arms/left))
					inventory_slot = "left arm"
				if(istype(src,/obj/equipment/arms/right))
					inventory_slot = "right arm"
				if(istype(src,/obj/equipment/hands))
					inventory_slot = "hands"
				if(istype(src,/obj/equipment/legs))
					inventory_slot = "legs"
				if(istype(src,/obj/equipment/feet))
					inventory_slot = "feet"
				if(usr.equipment[inventory_slot] == src)
					return

				//Now to see if the person has something else in the slot.
				if(usr.equipment[inventory_slot])
					//Unequip the equipped item
					var/obj/equipment/uneq = usr.equipment[inventory_slot]
					uneq.Unequip(usr)
				usr << "[src] equipped."
				src.suffix = "equipped"
				usr.attack += src.attackup
				usr.defense += src.defenseup
				usr.equipment[inventory_slot] = src
			Unequip(mob/user)
				//Optional arguement is a user, used for auto-unequip
				set src in usr

				if(!user)
					user = usr
					//If there's no arguement, default it to the verb's user.

				for(var/E in user.equipment)
					//Loop through the user's equipment list.
					if(user.equipment[E] == src)
						//Matched to your equipped item.
						user.equipment[E] = null
						user.defense -= src.defenseup
						user.attack -= src.attackup
						//Undoing the equipped item's effects.
						user << "[src] unequipped."
						src.suffix = ""

//Statpanel stuff

mob
	Stat()
		..()
		statpanel("Status")
		stat("Attack",attack)
		stat("Defense",defense)
		//So you can see item effects.

		statpanel("Equipment")
		for(var/E in equipment)
			//Looping through equipment and outputting stats based on the items found.
			if(equipment[E])
				var/obj/equipment/equipped = equipment[E]
				stat("[E]:","")
				stat(equipped)
			else
				stat("[E]"," ")
		statpanel("Inventory",contents)
		//Displaying your inventory.