world
	name = "Myths of Dragoon"
	hub = "UnknownPerson.TurnBasedBattleDemo"
	turf = /turf/grass



mob
	var
		maxhp
		hp

		mp

		str
		def
		agi
		int
		lck

		pdefence = 0 // percentage of physical damage taken off
		mdefence = 0 // percentage of magical damage taken off


		list/skills = newlist()

		logged
		inaction
		lock

		lastx
		lasty
		lastz
		inbattle
		monstermove




		mob/newchar

	soldier // short and sweet classes
		icon = 'auron.dmi'
		maxhp = 100
		maxmp = 0
		str = 20
		def = 14
		int = 9
		agi = 11
		lck = 35

		skills = newlist(/battle/battleskill/bighit) // skills included

	wizard
		icon = 'Magus.dmi'
		maxhp = 50
		maxmp = 70
		str = 12
		def = 13
		int = 24
		agi = 16
		lck = 25



	Hero
		icon = 'CLOUD WITH SWORD.dmi'
		maxhp = 150
		maxmp = 50
		str = 20
		def = 25
		int = 24
		agi = 30
		lck = 25



		skills = newlist(/battle/battleskill/zap,/battle/battleskill/bang)

	Login()
		if(src.logged) // only do this if you have a char already in

			src.Relocate()
			src.Regenerate()

			world << "[src] logs in."

			src << "Turn Based Battle Demo, created by Unknown Person"
			src << "Wander around the maze and beat the boss!"

		else // straightforward login
			var/list/classlist = list("Soldier","Wizard","Hero")
			var/cclass = input(src, "Pick a class","Class") in classlist
			switch(cclass)
				if("Soldier") src.newchar = new /mob/soldier ()
				if("Wizard")  src.newchar = new /mob/wizard  ()
				if("Hero")  src.newchar = new /mob/Hero ()

			newchar.name = src.key
			newchar.logged = 1
			new /item/potion (newchar) // start off with those
			new /item/ether (newchar)
			src.client.mob = newchar
			del(src)

	Logout()
		if(src.logged)
			world << "[src] logs off."
			del(src)
			..()

	Stat() // sweet and simple statpanel
		if(src.logged)
			if(statpanel("Statistics"))
				stat(src)
				stat("HP:    ","[src.hp]/[src.maxhp]")
				stat("MP:    ","[src.mp]/[src.maxmp]")
				stat("Strength: ",src.str)
				stat("Defence: ",src.def)
				stat("Intelligence: ",src.int)
				stat("Agility: ",src.agi)
				stat("Luck: ",src.lck)
				stat(null)
				stat("Skills:", null) // skills are shown here so when you click on it, your macro will turn to it
				if(src) stat(src.skills)
			if(statpanel("Inventory"))
				stat("Inventory -- ")
				if(src) stat(src.contents)
	Move()
		if(src.lock) return

		if(..()) // only randomencounter when you actually moved
			if(src.monstermove)
				var/monsterspawn/S = new src.monstermove
				if(S)
					if(prob(S.spawnchance)) // chance on this
						var/battlefield/A
						for(var/battlefield/b in world)
							if(b.fieldtype==S.fieldtype)
								if(!b.inuse)
									A = b // only pick the first one
									break
						if(A)
							var/list/MonList = S.monsterspawnlist
							var/thattype = pick(MonList) // pick one of the monsters the monsterspawn can spawn up
							var/mob/monsters/M = new thattype // create the mob
							src.lastx = src.x // save those necessary variables
							src.lasty = src.y
							src.lastz = src.z
							src.loc = A.loc
							src.lock = 1
							M.lock = 1
							M.loc = A.loc // move them to their positions
							src.y -= 2
							M.y += 2
							src.dir = NORTH // set their directions
							M.dir = SOUTH
							src.inbattle = 1 // put the in battle
							M.inbattle = 1

							new /battle_sorters (A.loc, src, M) // and away we go, this object controls the battle



	verb
		say(t as text) // no game can't have a say verb, even if it is a demo
			t = copytext(t,1,500)
			world << html_encode("[src]: [t]")


	proc
		DeathCheck(mob/M)
			if(src.hp<=0)
				src.dead = 1
				return 1
			else
				return 0

		Regenerate()
			src.hp = src.maxhp
			src.mp = src.maxmp
			src.dead = 0

		Relocate()
			src.loc = locate(/area/respawn)

proc
	luckchance(mob/M)
		var/chance = rand(1,100)
		if(chance<=M.lck) // lower your luck, worse the chance
			return 1
		else
			return 0


client
	Northwest() return  // disable all diagonal directions
	Northeast() return
	Southwest() return
	Southeast() return


area
	respawn
		Enter() return 1 // you are always able to enter the respawn

	monsterspawn
		var/monsterspawn/G
		Entered(atom/movable/A)
			if(ismob(A))
				var/mob/M = A
				if(M.client)
					M.monstermove = G // set your monstermove variable to it
		Exited(atom/movable/A)
			if(ismob(A))
				var/mob/M = A
				if(M.client)
					M.monstermove = null // can't be in a monster area forever

		slimers
			G = /monsterspawn/slimers

		guards
			G = /monsterspawn/guards


		boss
			G = /monsterspawn/boss


turf                        // sweet and simple turfs 'n objects
	icon = 'turfs.dmi'
	wall
		icon_state = "wall"
		density = 1
	walledge
		icon_state = "walledge"
		density = 1
	water
		icon_state = "water"
		density = 1
	grass
		icon_state = "grass"
	sand
		icon_state = "sand"
	woodfloor
		icon_state = "woodfloor"

	void
		icon_state = "black"
		density = 1
		opacity = 1

	regeneration_pad
		icon_state = "regen"
		Entered(atom/movable/A) // this is just for testing purposes
			if(ismob(A))
				var/mob/M = A
				M.Regenerate()
				M << "You have been regenerated to full health!"

obj
	icon = 'turfs.dmi'
	rock
		icon_state = "rock"
		density = 1
	tree
		icon_state = "tree"
		density = 1


battlefield
	parent_type = /obj
	var/inuse = 0
	var/fieldtype = "none"

	desert
		fieldtype = "desert"

	grasslands
		fieldtype = "grasslands"

	bossland
		fieldtype = "bossland"

item      // hey, since there are item capabilities in the battlefield, why don't we add potions?
	parent_type = /obj
	icon = 'items.dmi'
	proc									  ////
		Use(mob/M)							//
			view(M) << "[M] uses \an [src]."//////////////////////////////////////////
			sleep(10)						//										//
											  ////									//
																					//
		BattleUse()																	//
																					//
	Click()																			//
		if(src in usr.contents)														//
			if(!usr.inbattle)														//
				src.Use(usr)														//
																					//
                                                                                    //
	potion                                                                          //
		icon_state = "potion"                                                       //
		Use(mob/M)                                                                  //
			..() // incase you didn't know, ..() calls the original Use() proc so this is called
			view(M) << "[M] recovered 25 hit points."
			M.hp += 25
			if(M.hp > M.maxhp) M.hp = M.maxhp
			del(src)
		BattleUse(mob/M)
			view(M) << "[usr] uses \an [src]."
			sleep(10)
			view(M) << "[M] recovered 25 hit points."
			M.hp += 25
			if(M.hp > M.maxhp) M.hp = M.maxhp
			del(src)
	ether
		icon_state = "ether"
		Use(mob/M)
			..()
			view(M) << "[M] recovered 20 magic points."
			M.mp += 25
			if(M.mp > M.maxmp) M.mp = M.maxmp
			del(src)
		BattleUse(mob/M)
			view(M) << "[usr] uses \an [src]."
			sleep(10)
			view(M) << "[M] recovered 25 magic points."
			M.mp += 25
			if(M.mp > M.maxmp) M.mp = M.maxmp
			del(src)





